-- Ulf, 060322: Don't know what the bug was but it seems to be fixed now.

-- # import Property

-- Our domain (of sets)
D : Set

-- membership
infix 12 ∈
(∈) : D -> D -> Prop

-- subset
infix 12 ⊆
(⊆) : D -> D -> Prop

elimSub : (A,B,x:D) -> A ⊆ B /\ x ∈ A ==> x ∈ B
introSub (A,B:D) : ((x:D) -> x ∈ A ==> x ∈ B) ==> A ⊆ B

inter : D -> D -> D

axInter : (x,y,z:D) -> z ∈ inter x y <=> z ∈ x /\ z ∈ y

lemSubInter : (x,y,z:D) -> z ⊆ inter x y <=> z ⊆ x /\ z ⊆ y
lemSubInter x y z =
 let
   rem1 : z ⊆ inter x y ==> z ⊆ x
   rem1 = impI (\ h -> impE introSub ( \ t -> impI $ \ h1 ->
	    let rem11 : t ∈ z
                rem11 = fol-plugin(h,h1,elimSub)
	    in fol-plugin(axInter,h,h1,elimSub)))
   rem2 : z ⊆ inter x y ==> z ⊆ y
   rem2 = impI (\ h -> impE introSub ( \ t -> impI $ \ h1 -> fol-plugin(axInter,h,h1,elimSub)))
   rem3 : z ⊆ x /\ z ⊆ y ==> z ⊆ inter x y
   rem3 = impI (\ h -> impE introSub ( \ t -> impI $ \ h1 -> fol-plugin(axInter,h,h1,elimSub)))
 in
  fol-plugin(rem1,rem2,rem3)

