-- Test of infix parsing

Nat : Set

infixl 6 +, -
(+) : Nat -> Nat -> Nat
(-) : Nat -> Nat -> Nat

infixr 7 *
(*) : Nat -> Nat -> Nat

infixr 1 -->
(-->) : (A,B:Set) -> Set
(-->) = \A B -> A -> B

zero : Nat
succ : Nat --> Nat

one : Nat 
one = succ zero

foo : Nat --> Nat --> Nat
foo = \n m -> n + m * m - n

infixr 4 `foo`

bar : Nat 
bar = zero + one `foo` one `foo` zero

